<template lang="html">
  <transition name="slide-fade">
    <div v-show="open" class="profile-sidenav">
      <header class="nav-header">
        <div class="home-btn-container">
          <button type="button"
            class="home-btn">
            <svg class="home-btn-img" width="32" height="32" viewBox="0 0 200 200" xmlns="http://www.w3.org/2000/svg"><title>Enoplay</title><path d="M180 160.01V160h-80v40C44.772 200 0 155.228 0 100S44.772 0 100 0s100 44.772 100 100c0 22.516-7.442 43.295-20 60.01zM100 120c11.046 0 20-8.954 20-20s-8.954-20-20-20-20 8.954-20 20 8.954 20 20 20z" fill="#FFFFFF" fill-rule="evenodd"/></svg>
          </button>
        </div>
        <div class="nav-menu">
          <div class="exit-btn-container">
            <button class="nav-exit-btn"
              v-on:click="closeSideNav()">
              <svg width="24" height="24" viewBox="0 0 16 16" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><title>close-icon-white</title><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd"><g id="Artboard" transform="translate(-155.000000, -202.000000)" fill-rule="nonzero" fill="#FFFFFF"><polygon id="close-icon-white" points="171 203.611429 169.388571 202 163 208.388571 156.611429 202 155 203.611429 161.388571 210 155 216.388571 156.611429 218 163 211.611429 169.388571 218 171 216.388571 164.611429 210"></polygon></g></g></svg>
            </button>
          </div>
        </div>
        <h1 class="nav-title">{{ label.PROFILE }}</h1>
      </header>
      <div class="nav-content">
        <ep-profile-header
          :username="profile.username"
          :alias="profile.alias"
          :icon="profileIcon"
          :banner="profileBanner"></ep-profile-header>
        <ep-profile-nav
          :selected="navOption"
          v-on:select="selectNavOption($event)"></ep-profile-nav>
        <div class="profile-content">
          <ep-profile-home v-if="isSelectedNavOption('home')"
            :contentString="profile.description"></ep-profile-home>
          <ep-profile-game-list v-if="isSelectedNavOption('games')"
            :upload-list="userGamesPublished"></ep-profile-game-list>
        </div>
      </div>
    </div>
  </transition>
</template>

<script>
import { mapGetters, mapState, mapActions } from 'vuex'

import ProfileHeader from '../Profile/Header'
import ProfileNav from '../Profile/Nav'
import ProfileHome from '../Profile/Home'
import ProfileGameList from '../Profile/GameList'

export default {
  name: 'ep-profile-sidenav',
  components: {
    'ep-profile-header': ProfileHeader,
    'ep-profile-nav': ProfileNav,
    'ep-profile-home': ProfileHome,
    'ep-profile-game-list': ProfileGameList
  },
  props: {
    open: {
      type: Boolean,
      default () {
        return false
      }
    }
  },
  data () {
    return {
      isProfileInitialized: false,
      navOption: 'home',
      userGamesPublished: [],
      label: {
        PROFILE: 'Your Profile'
      }
    }
  },
  computed: {
    ...mapGetters([
      'profile'
    ]),
    ...mapState({
      profileIcon: state => {
        if (!(state.profile.media && state.profile.media.icon)) {
          return ''
        }
        return state.profile.media.icon.source
      },
      profileBanner: state => {
        if (!(state.profile.media && state.profile.media.banner)) {
          return ''
        }
        return state.profile.media.banner.source
      }
    })
  },
  watch: {
    profile () {
      if (this.isProfileInitialized || !this.profile.username) {
        return
      }

      this.$store.dispatch('getUserGamePublishHistory', this.profile.username)
      .then(gamesResponse => {
        this.userGamesPublished = gamesResponse
      })
      .catch(() => { /* Do nothing for now */ })

      this.isProfileInitialized = true
    }
  },
  methods: {
    ...mapActions('app', [
      'closeSideNav'
    ]),
    selectNavOption (option) {
      this.navOption = option
    },
    isSelectedNavOption (option) {
      return this.navOption === option
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/theme';

$header-height: 46px;
$font-size: 15px;
$menu-icon-padding: 32px;
$exit-icon-size: 24px;

$transition-speed: .1s;

.profile-sidenav {
  z-index: 10;
  position: fixed;
  top: 0;
  left: 0;
  height: 100%;
  background-color: #FFFFFF;
}

.nav-content {
  height: calc(100% - #{$header-height});
  overflow-y: scroll;
}

.nav-header {
  height: $header-height;
  background-color: $app-theme-color;

  .nav-menu {
    float: right;
    display: inline-block;
  }

  .home-btn-container, .exit-btn-container {
    height: $header-height;
  }

  .home-btn-container {
    float: left;
    margin-right: 8px;
    margin-left: 16px;
  }

  .home-btn, .nav-exit-btn {
    display: block;
    height: 100%;
    border: 0;
    margin: 0;
    padding: 0;
    background: transparent;
  }

  .nav-exit-btn {
    padding-left: $menu-icon-padding;
  }

  .exit-btn-container {
    margin-right: 16px;
  }

  .nav-title {
    display: table-cell;
    vertical-align: middle;
    height: $header-height;
    margin: 0;
    color: #FFFFFF;
    font-size: $font-size;
  }
}

.slide-fade-enter-active {
  transition: all $transition-speed ease;
}
.slide-fade-leave-active {
  transition: all $transition-speed ease;
}
.slide-fade-enter, .slide-fade-leave-to {
  transform: translateX(100%);
  opacity: 0;
}
</style>
